--
-- Module: 	MUX_16_1 
-- Design: 	TOP_ MUXES
-- VHDL code:	RTL code
--
-- Synthesis	Synopsys FPGA Express ver. 3.3 - Option = Preserve Hierarchy
--
-- Description: Multiplexer 16:1
-- 
-- Version: 1.0
--
--
--   Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY 
--                WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY 
--                IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
--                A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
--
--  Copyright (c) 2000 Xilinx, Inc.  All rights reserved.
-----------------------------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

-- Syntax for Synopsys FPGA Express
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on

entity MUX_16_1 is
    port (
        DATA_I		: in std_logic_vector (15 downto 0); 
        SELECT_I	: in std_logic_vector (3 downto 0);
        DATA_O		: out std_logic
	);
end MUX_16_1;

architecture MUX_16_1_arch of MUX_16_1 is
-- Component Decalrations:
component MUXF7
    port (
    	I0	: in std_logic;
    	I1	: in std_logic;
    	S	: in std_logic;
    	O	: out std_logic
    	);
end component;   	
--
-- Signal Declarations:
signal DATA_MSB : 	std_logic;
signal DATA_LSB : 	std_logic;
--
begin
--
-- If synthesis tools supports MUXF7 :
--SELECT_PROCESS: process (SELECT_I, DATA_I)
--begin
--	case SELECT_I is
--		when "0000" => DATA_O <= DATA_I (0);
--		when "0001" => DATA_O <= DATA_I (1);
--		when "0010" => DATA_O <= DATA_I (2);
--		when "0011" => DATA_O <= DATA_I (3);
--		when "0100" => DATA_O <= DATA_I (4);
--		when "0101" => DATA_O <= DATA_I (5);
--		when "0110" => DATA_O <= DATA_I (6);
--		when "0111" => DATA_O <= DATA_I (7);
--		when "1000" => DATA_O <= DATA_I (8);
--		when "1001" => DATA_O <= DATA_I (9);
--		when "1010" => DATA_O <= DATA_I (10);
--		when "1011" => DATA_O <= DATA_I (11);
--		when "1100" => DATA_O <= DATA_I (12);
--		when "1101" => DATA_O <= DATA_I (13);
--		when "1110" => DATA_O <= DATA_I (14);
--		when "1111" => DATA_O <= DATA_I (15);
--		when others => DATA_O <= 'X';
--	end case;
--end process SELECT_PROCESS;
--
-- If synthesis tools DOES NOT support MUXF7 :
SELECT_PROCESS_LSB: process (SELECT_I, DATA_I)
begin
	case SELECT_I (2 downto 0) is
		when "000" => DATA_LSB <= DATA_I (0);
		when "001" => DATA_LSB <= DATA_I (1);
		when "010" => DATA_LSB <= DATA_I (2);
		when "011" => DATA_LSB <= DATA_I (3);
		when "100" => DATA_LSB <= DATA_I (4);
		when "101" => DATA_LSB <= DATA_I (5);
		when "110" => DATA_LSB <= DATA_I (6);
		when "111" => DATA_LSB <= DATA_I (7);
		when others => DATA_LSB <= 'X';
	end case;
end process SELECT_PROCESS_LSB;
--
SELECT_PROCESS_MSB: process (SELECT_I, DATA_I)
begin
	case SELECT_I (2 downto 0) is
		when "000" => DATA_MSB <= DATA_I (8);
		when "001" => DATA_MSB <= DATA_I (9);
		when "010" => DATA_MSB <= DATA_I (10);
		when "011" => DATA_MSB <= DATA_I (11);
		when "100" => DATA_MSB <= DATA_I (12);
		when "101" => DATA_MSB <= DATA_I (13);
		when "110" => DATA_MSB <= DATA_I (14);
		when "111" => DATA_MSB <= DATA_I (15);
		when others => DATA_MSB <= 'X';
	end case;
end process SELECT_PROCESS_MSB;
--
-- MUXF7 instantiation
U_MUXF7: MUXF7
    port map (
    	I0 => DATA_LSB,
    	I1 => DATA_MSB,
    	S  => SELECT_I (3),
    	O  => DATA_O 
    );  
--
end MUX_16_1_arch;
