--
-- Module: 	MUX_2_1
-- Design: 	TOP_ MUXES
-- VHDL code:	RTL code
--
-- Synthesis	Synopsys FPGA Express ver. 3.3 - Option = Preserve Hierarchy
--
-- Description: Multiplexer 2:1
--
-- Version: 1.0
--
--   Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY 
--                WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY 
--                IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
--                A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
--
--  Copyright (c) 2000 Xilinx, Inc.  All rights reserved.
-----------------------------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

-- Syntax for Synopsys FPGA Express
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on

entity MUX_2_1 is
    port (
        DATA_I		: in std_logic_vector (1 downto 0); 
        SELECT_I	: in std_logic;
        DATA_O		: out std_logic
	);
end MUX_2_1;

architecture MUX_2_1_arch of MUX_2_1 is
--
begin
--
SELECT_PROCESS: process (SELECT_I, DATA_I)
begin
	case SELECT_I is
		when '0' => DATA_O <= DATA_I (0);
		when '1' => DATA_O <= DATA_I (1);
		when others => DATA_O <= 'X';
	end case;
end process SELECT_PROCESS;
--
end MUX_2_1_arch;
