--
-- Module: 	MUX_8_1 
-- Design: 	TOP_ MUXES
-- VHDL code:	RTL code
--
-- Synthesis	Synopsys FPGA Express ver. 3.3 - Option = Preserve Hierarchy
--
-- Description: Multiplexer 8:1
--
-- Version: 1.0
--
--   Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY 
--                WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY 
--                IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
--                A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
--
--  Copyright (c) 2000 Xilinx, Inc.  All rights reserved.
-----------------------------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

-- Syntax for Synopsys FPGA Express
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on

entity MUX_8_1 is
    port (
        DATA_I		: in std_logic_vector (7 downto 0); 
        SELECT_I	: in std_logic_vector (2 downto 0);
        DATA_O		: out std_logic
	);
end MUX_8_1;

architecture MUX_8_1_arch of MUX_8_1 is
--
begin
--
SELECT_PROCESS: process (SELECT_I, DATA_I)
begin
	case SELECT_I is
		when "000" => DATA_O <= DATA_I (0);
		when "001" => DATA_O <= DATA_I (1);
		when "010" => DATA_O <= DATA_I (2);
		when "011" => DATA_O <= DATA_I (3);
		when "100" => DATA_O <= DATA_I (4);
		when "101" => DATA_O <= DATA_I (5);
		when "110" => DATA_O <= DATA_I (6);
		when "111" => DATA_O <= DATA_I (7);
		when others => DATA_O <= 'X';
	end case;
end process SELECT_PROCESS;
--
end MUX_8_1_arch;
